/**
 * Sorting plug-in for DataTables "yesnoidat" 
 * sorts fields that have no 'data-subject="vorname' defined to the end of the table
 * 
 * @name: patientlist no-idat sorter
 * @summary: sorts fields that have no 'data-subject="vorname' defined to the end of the table
 * @example
 *   $('#mytable').dataTable({
 *      columnDefs: [
 *        { targets: 0, type: 'yesnoidat' }
 *      ]
 *   });
 */ 

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
	"yesnoidat-asc" : function(str1, str2) {
		if(str1.indexOf("data-subject=\"vorname") == -1) {
            return 1;
		}
		if(str2.indexOf("data-subject=\"vorname") == -1) {
            return -1;
		}
        return ((str1 < str2) ? -1 : ((str1 > str2) ? 1 : 0));
	},
	"yesnoidat-desc" : function(str1, str2) {
		if(str1.indexOf("data-subject=\"vorname") == -1)
            return 1;
		if(str2.indexOf("data-subject=\"vorname") == -1)
            return -1;
        return ((str1 < str2) ? 1 : ((str1 > str2) ? -1 : 0));
	 }
});




//clipboard function

$(document).ready(function()  {

    var clipboard = new Clipboard('.clipboard', {
        text: function(trigger) {
            return $(trigger).parents("tr").find("[data-subject='pid']").text();
        }
    });

    // $('.clipboard').tooltip({
    //     trigger: 'click',
    //     placement: 'bottom',
		// delay:{show:4000, hide:4000},
    // });


    function setTooltip(btn, message) {

        $(btn).tooltip('hide')
            .attr('data-original-title', message)
            .tooltip('show');
    }

    function hideTooltip(btn) {
        setTimeout(function() {
            $(btn).tooltip('hide');
        }, 1000);
    }

    clipboard.on('success', function(e) {

        $($(e.trigger).parents("tr").find("[data-subject='pid']")).tooltip({
            trigger: 'click',
            placement: 'bottom',
            // delay:{show:4000, hide:4000},
        });

        setTooltip($(e.trigger).parents("tr").find("[data-subject='pid']"), 'Copied!');
        hideTooltip($(e.trigger).parents("tr").find("[data-subject='pid']"));
    });



})